-# Common helper routines for test shell scripts -- intended to be sourced by them
+# Common helper routines for test shell scripts -- to be sourced by them
# @configure_input@
-#### The following exported variables are set by "make check". Ensure
+#### The following variables are set by "make check". Ensure
#### that they are set here so that individual tests can be run
#### outside of make. Requires that MH_OBJ_DIR be set on entry.
-test -z "$MH_TEST_DIR" && MH_TEST_DIR="$MH_OBJ_DIR/test/testdir"
+#### Use the result of cd and pwd -P so that the result will agree
+#### with what getcwd(3) returns.
+test -d "$MH_OBJ_DIR/test/testdir" || mkdir -p "$MH_OBJ_DIR/test/testdir"
+test -z "$MH_TEST_DIR" && MH_TEST_DIR=`cd "$MH_OBJ_DIR/test/testdir" && pwd -P`
+export MH_TEST_DIR
+test -z "$MH_INST_DIR" && MH_INST_DIR="${MH_TEST_DIR}/inst"
+test -z "$MH_VERSION" && MH_VERSION="@VERSION@"
test -z "$prefix" && prefix=@prefix@
test -z "$datarootdir" && datarootdir=@datarootdir@
test -z "$exec_prefix" && exec_prefix=@exec_prefix@
-test -z "$nmhexecdir" && nmhexecdir="@libexecdir@/nmh"
test -z "$bindir" && bindir="@bindir@"
test -z "$mandir" && mandir="@mandir@"
test -z "$nmhetcdir" && nmhetcdir="@sysconfdir@/nmh"
+#### The following doesn't support running the distcheck version of
+#### test-mhparam standalone, but only via make distcheck.
+test -z "$nmhetcdirinst" && nmhetcdirinst="@nmhetcdirinst@$nmhetcdir"
+test -z "$nmhlibexecdir" && nmhlibexecdir="@libexecdir@/nmh"
test -z "$supported_locks" && supported_locks="@supported_locks@"
test -z "$default_locking" && default_locking="@default_locking@"
test -z "$MULTIBYTE_ENABLED" && MULTIBYTE_ENABLED="@MULTIBYTE_ENABLED@"
test -z "$ICONV_ENABLED" && ICONV_ENABLED="@ICONV_ENABLED@"
-export MH_TEST_DIR nmhexecdir bindir mandir nmhetcdir
-export MULTIBYTE_ENABLED ICONV_ENABLED
+test -z "$OAUTH_SUPPORT" && OAUTH_SUPPORT="@OAUTH_SUPPORT@"
+test -z "$CURL_USER_AGENT" && CURL_USER_AGENT="@CURL_USER_AGENT@"
-test -z "$MH_INST_DIR" && MH_INST_DIR="${MH_TEST_DIR}/inst"
-export MH_INST_DIR
+#### Make sure that HOME is set to avoid run-time warning from w3m about
+#### not being able to create config directory.
+HOME="$MH_TEST_DIR"
+export HOME
unset MAILDROP MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
-unset MHLDEBUG MHPDEBUG MHWDEBUG PAGER
+unset MHLDEBUG MHWDEBUG PAGER XOAUTH SMTPUTF8
#### Set LC_ALL in individual tests as needed. Unset these so
#### that we don't depend on user's settings in other tests.
unset LANG LC_ALL LC_CTYPE
#### Use a test dir for tmp files when MHTMPDIR applies.
-MHTMPDIR=$MH_TEST_DIR/Mail
+MHTMPDIR="$MH_TEST_DIR"/Mail
export MHTMPDIR
+#### If you're reading this .... you can set MH_TEST_NOCLEANUP to prevent
+#### the test suite from cleaning up the results of a test run, if you need
+#### to do manual debugging on a test.
+
output_md5()
{
#### Output just the checksum. If the filename needs to appear on
test_skip ()
{
- WHY="$1"
- echo "$Test $0 SKIP ($WHY)"
+ why="$1"
+ echo "$0: skipped: $why"
exit 77
}
}
# Skip test if none of the offered locales are supported.
+# As side effect, use the first locale that is found. Note that
+# some platforms allow, by way of example, en_US.UTF-8 to be used
+# even though en_US.UTF8 is listed by locale -a. But by setting
+# LC_ALL here, we don't rely on that.
require_locale ()
{
for locale in "$@"; do
if locale -a | grep -i "$locale" >/dev/null; then
+ LC_ALL="$locale"; export LC_ALL
return
fi
done
set +e
printf '' > "${MH_TEST_DIR}/$$-1"
+ xdir_links_supported=0
if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2" 2>/dev/null; then
hard_links_supported=1
+ mkdir "${MH_TEST_DIR}/xlinkdir"
+ if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/xlinkdir/$$-2" 2>/dev/null; then
+ xdir_links_supported=1
+ fi
else
hard_links_supported=0
fi
rm -f "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2"
+ rm -rf "${MH_TEST_DIR}/xlinkdir"
set -e
}
#### check() requires two arguments, each the name of a file to be
#### diff'ed.
-#### If the contents are same, the second file is removed. And the
-#### first file is removed unless there's an optional argument with
-#### a value of 'keep first'.
-#### If different, global variable "failed" is incremented.
-#### If there's an optional 'ignore space' argument, spacing differences
-#### will not be considered signficant, emulating GNU diff -w. It
-#### is assumed that the first file has already been run through
-#### prepare_space.
+#### If the contents are same, the second file is removed. If different,
+#### global variable "failed" is incremented.
+#### Optional arguments:
+#### 'keep first' -- first file is removed unless this is present.
+#### 'ignore space' -- spacing differences will not be considered
+#### significant, emulating GNU diff -w. It is assumed that the
+#### first file has already been run through prepare_space.
+#### ':' <test name> -- will print '<test name>' in the failure message,
+#### to make it easier to tell which of multiple tests has failed.
check() {
first=$1; shift
second=$1; shift
keepfirst=
ignorespace=
+ label=test
while [ $# -gt 0 ]; do
case $1 in
'keep first') keepfirst=1 ;;
'ignore space') ignorespace=1 ;;
+ ':') shift; label=\'"$*"\'; break ;;
*) echo "$0: invalid check() argument \"$1\" in test suite" >&2 ;;
esac
shift
#### POSIX diff should support -c.
diff -c "$first" "$second" || true
echo
- echo "$0: test failed, outputs are in $first and $second."
+ echo "$0: $label failed, outputs are in $first and $second."
failed=`expr ${failed:-0} + 1`
#### Set return status of the function.
[ $failed -eq 0 ]
fi
}
+#### check_exit() runs the command in $2..., capturing stdout and
+#### stderr, and then tests its exit status with the test(1) condition
+#### in $1. If that fails, the captured stdout and stderr are
+#### displayed, and $failed incremented.
+check_exit() {
+ c="$1"; shift
+ t="$MH_TEST_DIR/.check_exit"
+ r=0
+ $NMH_TEST_PREFIX "$@" >"$t.1" 2>"$t.2" || r=$?
+ if test $r $c; then
+ rm "$t.1" "$t.2"
+ else
+ echo "$0: check_exit: $r $c failed: $*" >&2
+ echo " stdout:" >&2
+ sed 's/^/ /' "$t.1" >&2
+ echo " stderr:" >&2
+ sed 's/^/ /' "$t.2" >&2
+ failed=`expr ${failed:-0} + 1`
+ fi
+}
+
+#### Function invoked by trap on exit.
+cleanup() {
+ #### Save exit status to use as status for this program.
+ status=$?
+
+ #### Clean up test mail space.
+ #### cd to $MH_TEST_DIR before trying to remove its Mail
+ #### subdirectory. rm on Solaris won't remove it if it's in the
+ #### path of the current working directory.
+ test -z "$MH_TEST_NOCLEANUP" && (cd "$MH_TEST_DIR"; rm -rf "$MH_TEST_DIR"/Mail)
+
+ #### Report test name if set, which indicates failure.
+ #### Relies on set -e to invoke the trap which calls
+ #### this function on failure.
+ #### To use:
+ #### 1) Set test name before running the test, use start_test().
+ #### 2) Unset upon successful completion, use finish_test().
+ if test -n "$nmh_tests_testname"; then
+ echo "first named test failure: $nmh_tests_testname"
+ fi
+
+ #### Exit with non-zero status if failure. Failure is defined as either
+ #### non-empty nmh_tests_testname or non-zero exit status on entry to the
+ #### function.
+ if test -n "$nmh_tests_testname" -o $status -ne 0; then
+ test $status -ne 0 && exit $status || exit 1
+ test $status -ne 0 && exit 0 || exit 0
+ fi
+}
+
+#### Function to set the test name, and whatever the future brings.
+start_test() {
+ #### run_test disables exit on non-zero status, but does increment
+ #### failed. Don't overwrite nmh_tests_testname if there was a
+ #### failure; remember the first test that failed.
+ [ ${failed:-0} -eq 0 ] && nmh_tests_testname="$1"
+}
+
+#### Corresponding function to indicate that the test has finished. It need
+#### not be called after each test, just the last one in a file.
+finish_test() {
+ #### run_test disables exit on non-zero status, but does increment
+ #### failed. Don't unset nmh_tests_testname if there was a failure.
+ [ ${failed:-0} -eq 0 ] && unset nmh_tests_testname
+}
+
setup_test ()
{
+ set -e
+
MH="${MH_TEST_DIR}/Mail/.mh_profile"
MHMTSCONF="${MH_INST_DIR}${nmhetcdir}/mts.conf"
- MH_LIBEXEC_DIR="${MH_INST_DIR}${nmhexecdir}"
+ MH_LIBEXEC_DIR="${MH_INST_DIR}${nmhlibexecdir}"
export MH MHMTSCONF MH_LIBEXEC_DIR
#
PATH="${MH_INST_DIR}${bindir}:${PATH}"
export PATH
- # clean old test data
- trap "cd $MH_TEST_DIR; rm -rf '$MH_TEST_DIR/Mail'" 0
+ # clean old test data on exit
+ trap cleanup 0
+
# setup test data
mkdir -p "$MH_TEST_DIR/Mail" || exit 1
cat > "$MH" <<EOF || exit 1
mhlproc: ${MH_LIBEXEC_DIR}/mhl
moreproc: cat
postproc: ${MH_LIBEXEC_DIR}/post
+showmimeproc: ${MH_INST_DIR}${bindir}/mhshow
showproc: ${MH_LIBEXEC_DIR}/mhl
+#: The following aren't currently used by the test suite, but are
+#: defined here in case they are in the future:
+mailproc: ${MH_INST_DIR}${bindir}/mhmail
+rcvstoreproc: ${MH_LIBEXEC_DIR}/rcvstore
+sendproc: ${MH_INST_DIR}${bindir}/send
+whatnowproc: ${MH_INST_DIR}${bindir}/whatnow
+whomproc: ${MH_INST_DIR}${bindir}/whom
+#: incproc and packproc are defined in config.c but not used by any code.
EOF
- for f in MailAliases components digestcomps distcomps forwcomps mhl.body \
- mhl.digest mhl.format mhl.forward mhl.headers mhl.reply* \
- mhn.defaults rcvdistcomps replcomps replgroupcomps scan.MMDDYY \
- scan.YYYYMMDD scan.curses scan.default scan.highlighted scan.mailx \
- scan.nomime scan.size scan.time scan.timely scan.unseen
- do
- cp "${MH_INST_DIR}${nmhetcdir}/"${f} "${MH_TEST_DIR}/Mail" || exit 1
- done
+ if test -z '@nmhetcdirinst@'; then
+ #### This isn't used with make distcheck, so that we can use it to
+ #### be sure that etc files are not used from an existing nmh
+ #### installation.
+ #### posh doesn't like "${MH_INST_DIR}${nmhetcdir}"/*, so cd to
+ #### the directory and provide an argument without quotes to cp.
+ (cd "${MH_INST_DIR}${nmhetcdir}/" && cp * "${MH_TEST_DIR}/Mail")
+ fi
folder -create +inbox > /dev/null
+ #### Suppress warnings about a new version.
+ #### mhparam version includes the nmh- prefix, so be consistent with that.
+ printf 'Version: nmh-%s\n' "${MH_VERSION}" >> "${MH_TEST_DIR}"/Mail/context
+
# create 10 basic messages
for i in 1 2 3 4 5 6 7 8 9 10;
do